"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.get = get;
exports.onChange = onChange;
exports.set = set;
let colorMode = 'light';
const eventsCallbacks = [];
function set(colorModeValue) {
  colorMode = colorModeValue;
  eventsCallbacks.forEach(callback => {
    callback(colorModeValue);
  });
}
function get() {
  return colorMode;
}
function onChange(callback) {
  eventsCallbacks.push(callback);
  return () => {
    const index = eventsCallbacks.indexOf(callback);
    if (index !== -1) {
      eventsCallbacks.splice(index, 1);
    }
  };
}
//# sourceMappingURL=colorMode.js.map