"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createGlobalStyles = void 0;
var _convertSxToSxVerbosed = require("./convertSxToSxVerbosed");
var _stableHash = require("./stableHash");
var _utils = require("./utils");
var _updateOrderUnResolvedMap = require("./updateOrderUnResolvedMap");
const createGlobalStyles = (globalStyle, Platform) => {
  const versboseComponentTheme = (0, _convertSxToSxVerbosed.convertStyledToStyledVerbosed)(globalStyle);
  (0, _utils.resolvePlatformTheme)(versboseComponentTheme, Platform.OS);
  const componentHash = (0, _stableHash.stableHash)({
    ...globalStyle
  });
  const {
    styledIds,
    verbosedStyleIds
  } = (0, _updateOrderUnResolvedMap.updateOrderUnResolvedMap)(versboseComponentTheme, componentHash, 'global', {});
  return {
    globalStyleIds: styledIds,
    globalVerbosedStyleIds: verbosedStyleIds,
    globalTheme: versboseComponentTheme
  };
};
exports.createGlobalStyles = createGlobalStyles;
//# sourceMappingURL=createGlobalStyles.js.map