"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useColorMode = void 0;
var _colorMode = require("../core/colorMode");
var _react = require("react");
/**
 *
 * @returns Current color mode value (light or dark)
 */
const useColorMode = () => {
  const [currentColorMode, setCurrentColorMode] = (0, _react.useState)((0, _colorMode.get)());
  (0, _react.useEffect)(() => {
    (0, _colorMode.onChange)(colorMode => {
      setCurrentColorMode(colorMode);
    });
    // remove onchage listener on unmount
    () => (0, _colorMode.onChange)(colorMode => {
      setCurrentColorMode(colorMode);
    });
  }, []);
  return currentColorMode;
};
exports.useColorMode = useColorMode;
//# sourceMappingURL=useColorMode.js.map