"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useMedia = void 0;
var _reactNative = require("react-native");
var _generateStylePropsFromCSSIds = require("../generateStylePropsFromCSSIds");
var _StyledProvider = require("../StyledProvider");
const useMedia = () => {
  var _theme$config;
  const theme = (0, _StyledProvider.useStyled)();
  const {
    width
  } = (0, _reactNative.useWindowDimensions)();
  const mediaQueries = theme === null || theme === void 0 || (_theme$config = theme.config) === null || _theme$config === void 0 || (_theme$config = _theme$config.tokens) === null || _theme$config === void 0 ? void 0 : _theme$config.mediaQueries;
  const breakpoints = {};
  Object.keys(mediaQueries).forEach(currentBreakPoint => {
    breakpoints[currentBreakPoint] = (0, _generateStylePropsFromCSSIds.isValidBreakpoint)(theme === null || theme === void 0 ? void 0 : theme.config, mediaQueries[currentBreakPoint], width);
  });
  return breakpoints;
};
exports.useMedia = useMedia;
//# sourceMappingURL=useMedia.js.map