"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.injectComponentAndDescendantStyles = injectComponentAndDescendantStyles;
var _styleSheet = require("../style-sheet");
var _getComponentStyle = require("./getComponentStyle");
function injectComponentAndDescendantStyles(orderedResolved, styleTagId, type = 'boot', _GluestackStyleSheet = _styleSheet.GluestackStyleSheet, platform = '', inlineStyleMap, ignoreKeys = new Set(), CONFIG = {}) {
  const [componentOrderResolvedBaseStyle, componentOrderResolvedBaseStateStyle] = (0, _getComponentStyle.getComponentResolvedBaseStyle)(orderedResolved);
  const [componentOrderResolvedVariantStyle, componentOrderResolvedVariantStateStyle] = (0, _getComponentStyle.getComponentResolvedVariantStyle)(orderedResolved);
  const [descendantOrderResolvedBaseStyle, descendantOrderResolvedBaseStateStyle] = (0, _getComponentStyle.getDescendantResolvedBaseStyle)(orderedResolved);
  const [descendantOrderResolvedVariantStyle, descendantOrderResolvedVariantStateStyle] = (0, _getComponentStyle.getDescendantResolvedVariantStyle)(orderedResolved);
  const componentOrderResolvedBaseStyleIds = _styleSheet.GluestackStyleSheet.declare([...componentOrderResolvedBaseStyle, ...componentOrderResolvedBaseStateStyle], type + '-base', styleTagId ? styleTagId : 'css-injected-boot-time', {});
  const descendantOrderResolvedBaseStyleIds = _styleSheet.GluestackStyleSheet.declare([...descendantOrderResolvedBaseStyle, ...descendantOrderResolvedBaseStateStyle], type + '-descendant-base', styleTagId ? styleTagId : 'css-injected-boot-time-descendant', {});
  const componentOrderResolvedVariantStyleIds = _styleSheet.GluestackStyleSheet.declare([...componentOrderResolvedVariantStyle, ...componentOrderResolvedVariantStateStyle], type + '-variant', styleTagId ? styleTagId : 'css-injected-boot-time', {});
  const descendantOrderResolvedVariantStyleIds = _styleSheet.GluestackStyleSheet.declare([...descendantOrderResolvedVariantStyle, ...descendantOrderResolvedVariantStateStyle], type + '-descendant-variant', styleTagId ? styleTagId : 'css-injected-boot-time-descendant', {});
  const styleCSSIdsArr = [...componentOrderResolvedBaseStyleIds, ...descendantOrderResolvedBaseStyleIds, ...componentOrderResolvedVariantStyleIds, ...descendantOrderResolvedVariantStyleIds];
  const toBeInjected = _styleSheet.GluestackStyleSheet.resolve(styleCSSIdsArr, CONFIG, {}, false, type, ignoreKeys);
  if (platform === 'web') {
    _styleSheet.GluestackStyleSheet.inject(toBeInjected, inlineStyleMap);
  }
  return styleCSSIdsArr;
}
//# sourceMappingURL=injectComponentAndDescendantStyles.js.map