"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _createDeclarationBlock = _interopRequireDefault(require("../utils/create-declaration-block"));
var _common = require("../utils/common");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const createStyleSheet = (stylesObject, dataHash = 'media', prefixClassName = '', hasState = false, prefixColorMode = 'gs-') => {
  if (!stylesObject) return {
    ids: {},
    styles: {},
    fullStyles: {}
  };
  let ids = {};
  let rules = {};
  const cleanStyles = (0, _common.deepClone)(stylesObject);
  Object.keys(stylesObject).map(key => {
    var _ids;
    if (!(stylesObject !== null && stylesObject !== void 0 && stylesObject[key])) return;
    let {
      condition,
      colorMode,
      style,
      theme
    } = stylesObject[key];
    const mediaQuery = (0, _common.createQuery)(condition);
    let finalColorMode = typeof colorMode === 'string' ? colorMode : condition === null || condition === void 0 ? void 0 : condition.colorMode;
    const colorSchemeQuery = (0, _common.createQuery)(finalColorMode);
    const css = (0, _createDeclarationBlock.default)(style);
    const themeCssObj = {};
    // if (themeCondition) {
    //   Object.keys(themeCondition).forEach((themeName) => {
    //     const themeConditionValue = themeCondition[themeName];
    //     themeCssObj[themeName] = createDeclarationBlock(themeConditionValue);
    //   });
    // }
    // console.log(css, style, 'css', mediaQuery, 'mediaQuery', colorSchemeQuery);

    // const stringHash = `cssinjected-${hash(`${key}${css}`)}`;

    const rule = (0, _common.createCssRule)(mediaQuery, colorSchemeQuery, finalColorMode, dataHash, css, 'style', prefixClassName, prefixColorMode, hasState, theme, themeCssObj);
    delete cleanStyles[key];
    ids = {
      ...ids,
      [key]: `${(_ids = ids) !== null && _ids !== void 0 && _ids[key] ? ids[key] + ' ' : ''}${dataHash}`
    };
    rules = {
      ...rules,
      [key]: rule
    };
  });
  // console.log(rules, 'ids here');

  return {
    ids,
    rules,
    styles: cleanStyles,
    fullStyles: stylesObject
  };
};
var _default = exports.default = createStyleSheet;
//# sourceMappingURL=index.js.map