"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _createReactDOMStyle = _interopRequireDefault(require("./react-native-web/createReactDOMStyle"));
var _prefixStyles = _interopRequireDefault(require("./react-native-web/prefixStyles"));
var _hyphenateStyleName = _interopRequireDefault(require("./react-native-web/hyphenate-style-name"));
var _preprocess = require("./react-native-web/preprocess");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
// @ts-nocheck

function orderStyleObjectBySpecificity(obj) {
  //TODO: add specificity for border
  const SPREAD_PROP_SPECIFICITY_ORDER = ['padding', 'paddingHorizontal', 'paddingVertical', 'paddingTop', 'paddingBottom', 'paddingLeft', 'paddingRight', 'margin', 'marginHorizontal', 'marginVertical', 'marginTop', 'marginBottom', 'marginLeft', 'marginRight', 'borderWidth', 'borderBottomWidth', 'borderLeftWidth', 'borderRightWidth', 'borderTopWidth', 'borderRadius', 'borderTopLeftRadius', 'borderTopRightRadius', 'borderBottomLeftRadius', 'borderBottomRightRadius'];
  const orderedArr = [];
  SPREAD_PROP_SPECIFICITY_ORDER.forEach(key => {
    if (obj.hasOwnProperty(key)) {
      orderedArr.push([key, obj[key]]);
      delete obj[key];
    }
  });
  const remainingKeys = Object.keys(obj);
  remainingKeys.forEach(key => {
    orderedArr.push([key, obj[key]]);
  });
  return orderedArr;
}
const createDeclarationBlock = style => {
  const domStyle = (0, _prefixStyles.default)((0, _createReactDOMStyle.default)((0, _preprocess.preprocess)(style)));
  const orderedDomStyle = orderStyleObjectBySpecificity(domStyle);
  const declarationsString = orderedDomStyle.map(property => {
    const value = property[1];
    const prop = (0, _hyphenateStyleName.default)(property[0]);
    if (Array.isArray(value)) {
      return value.map(v => `${prop}:${v}`).join(';');
    } else {
      return `${prop}:${value}`;
    }
  }).join(';');
  return `{${declarationsString};}`;
};
var _default = exports.default = createDeclarationBlock;
//# sourceMappingURL=create-declaration-block.js.map